:- module(ejockey2, []).

:- use_module(pac(basic)).
:- use_module(pac(reduce)).
:- use_module(pac(meta)).
:- use_module(util(misc)).
:- use_module(util(file)).
:- use_module(util('prolog-elisp')).
:- use_module(util('emacs-handler')).
:- use_module(util(obj)).
:- use_module(pac(op)).

term_expansion --> pac:expand_pac.

:- discontiguous handle/3.

			/***********************
			*    YA Emacs Handler  *
			***********************/
%
handle([test1]) --> region,
	peek("Hello World!\n"),
	overwrite.

handle([skk, user, jisyo]) -->
	{	Input = '~/Dropbox/skkdict/math-symbol.plist',
		Output = '~/Desktop/math-symbol-dummy.utf8',
		expand_file_name(Input, [In]),
		expand_file_name(Output, [Out]),
		plist_to_dict(In, Out)
	}.
%
plist_to_dict(In, Out):-
	load_structure(In, XML, []),
	parse_xml_structure(Dict0, [], XML, []),
	convert_to_skk_dict(Dict0, Dict),
	setup_call_cleanup(open(Out, write, S),
					  	(	write_head_lines(S),
							write_dict(S, Dict)
						),
					   close(S)).

%
parse_xml_structure([key(A,B)|Out], Out0)-->[element(key, A,B)], !,
	parse_xml_structure(Out, Out0).
parse_xml_structure([string(A,B)|Out], Out0)-->[element(string, A, B)], !,
	parse_xml_structure(Out, Out0).
parse_xml_structure(Out, Out0)-->[element(_, _, X)], !,
	{ phrase(parse_xml_structure(Out, Out1), X, []) },
	parse_xml_structure(Out1, Out0).
parse_xml_structure(Out, Out0)-->[_], !, parse_xml_structure(Out, Out0).
parse_xml_structure(Out, Out)-->[].

%
convert_to_skk_dict([], []).
convert_to_skk_dict([key(_, [K]), string(_, [S])|D], [A|D0]):- A=..[K, S],
	convert_to_skk_dict(D, D0).
%
head_lines(
	  [		";; -*- mode: fundamental; coding: utf-8 -*-\n",
			";;\n",
			";; okuri-ari entries.\n",
			";; okuri-nasi entries.\n"
	  ]).
%
write_head_lines(S):- head_lines(Hs), maplist(write(S), Hs).
%
write_dict(_, []).
write_dict(S, [phrase(P), shortcut(C)|R]):-
	format(S, "~w /~w/~n", [C, P]),
	write_dict(S, R).
%
