:- module(env_dict, [initialize_env/0]).

% initialization for CGI on local mac.

paths_to_exec([	CGIBIN,
				USERBIN,
				"/usr/local/bin/",
				"/Library/TeX/texbin/",
				"/bin/",
				"/usr/bin/"])	:-
		getenv(cgi_bin, CGIBIN),
		getenv(home, HOME),
		concat_atom([HOME, 'local/bin'], /, USERBIN).
%
expand_file_path(F, Full):- expand_file_name(F, [Full]).
%
initialize_env:-
	getenv(user, USER),
	getenv(home, HOME),
	paths_to_exec(Ps),
	maplist(expand_file_path, Ps, Qs),
	concat_atom(Qs, ':', P),
	setenv(path, P),
	getenv(home, HOME),
	concat_atom([HOME, public_html], /, Public_html),
	setenv(public_html_dir, Public_html),
	setenv(exercise_js_name, 'http_request.js'),
	setenv(http_prefix, 'http://localhost'),  % http://web.sfc.keio.ac.jp' for CNS.
	getenv(http_prefix, H),
	concat_atom([H, '/~', USER, /, 'cgi-bin'], C),
	setenv(cgi_prefix, C),
	setenv(notify_cgi_access_by_mail, false). 	% true for CNS
