:- module(latex_control, []).

user:file_search_path(sty, X):-  getenv(home, X0),
	atomic_list_concat([X0, '/cabinet/TeX/preambles'], X).


% jarticle([file(sty('jarticle.tex')),
% 	file(sty('macro-2009-jp.tex')),
% 	text("\n\\begin{document}\n"),
% 	region,
% 	text("\n\\end{document}\n")
%        ]).

jarticle([file(sty('jarticle.tex')),
	text("\\langjptrue\n"),
    	text("\\input prooftree\n"),
	text("\\input environments\n"),
 	text("\\input standard-symbols\n"),
	text("\\input symbols-2009b\n"),
	text("\n\\begin{document}\n"),
	region,
	text("\\end{document}\n")
       ]).


powerdot([file(sty('powerdot2009.tex')),
	text("\\langjptrue\n"),
    	text("\\input prooftree\n"),
	text("\\input environments\n"),
 	text("\\input standard-symbols\n"),
	text("\\input symbols-2009b\n"),
	text("\n\\begin{document}\n"),
	region,
	text("\\end{document}\n")
       ]).


uarticle([file(sty('uarticle.tex')),
	text("\\langjptrue\n"),
	text("\\input environments\n"),
 	text("\\input standard-symbols\n"),
	text("\\input symbols-2009b\n"),
	text("\n\\begin{document}\n"),
	region,
	text("\\end{document}\n")
       ]).

xarticle([file(sty('xarticle.tex')),
	text("\\langjpfalse\n"),
 	text("\\input xenvironments\n"),
  	text("\\input standard-symbols\n"),
	text("\\input symbols-2009b\n"),
	text("\n\\begin{document}\n"),
	region,
	text("\\end{document}\n")
       ]).

% xarticle([file(sty('xarticle.tex')),
% % 	text("\\input macro-2009-jp\n"),
% 	text("\n\\begin{document}\n"),
% 	region,
% 	text("\\end{document}\n")
%        ]).

:- meta_predicate(latex_control(?, 1)).
latex_control(TeX_Distr, P) :- call(P, Fs),  cur_dir(D),
	directory(D, latex_control_(TeX_Distr, Fs)).

latex_control_(D, Fs):- eh:assemble(Fs, '_region_.tex'), latex_control(D).


latex_control(ptex) :- !,
	sh('use-ptex';
     	     platex('_region_');
	     dvipdfmx('_region_');
	     open(-a('Preview'), '_region_.pdf')).
latex_control(uptex) :- !,
	sh('use-uptex';
	     uplatex('_region_');
	     '~/texbin/dvipdfmx'('_region_');
	     open(-a('Preview'), '_region_.pdf')).
latex_control(xetex) :-
	sh('use-xetex';
	     xelatex('_region_');
	     open(-a('Preview'), '_region_.pdf')).
